<template>
  <header class="ResourceHeader">
    <BreadcrumbBar />
    <span v-if="!props.loading" class="ResourceHeader__CreatedAt">
      {{ t(`resource.${props.resourceType}.createdAt`) }}
      {{ createdAt }}
    </span>
    <PSkeleton v-if="props.loading" width="200px" />

    <!-- Main button -->
    <PButton
      v-show="!props.editMode"
      v-if="!props.loading"
      :label="t(unref(actionButton.label))"
      :icon="actionButton.icon"
      class="ResourceHeader__Action p-button-outlined"
      @click="actionButton.command"
    />

    <PButton
      v-show="props.items?.length && !props.editMode"
      type="button"
      icon="mdi mdi-dots-vertical"
      class="ResourceHeader__MenuButton p-button-text"
      aria-haspopup="true"
      aria-controls="overlay_menu"
      @click="toggle"
    />

    <PMenu id="overlay_menu" ref="menu" :model="menuItems" :popup="true" />
  </header>
</template>

<script lang="ts" setup>
import { computed, ref, unref } from 'vue'
import { MenuItem, translate } from '@/components/bars/MenuItem'
import BreadcrumbBar from '@/components/resources/BreadcrumbBar.vue'
import moment from 'moment-timezone'
import { Now } from '@/states'
import { useI18n } from 'vue-i18n'
import { ActionItem } from '@/components/bars/MenuItem'

const props = defineProps<{
  resourceType: string
  resource?: { createdAt?: Date }
  loading: boolean
  editMode: boolean
  mainAction?: ActionItem
  items?: MenuItem[]
  noModifyButton?: boolean
}>()

const { t } = useI18n()
const actionModify: ActionItem = {
  label: 'action.edit',
  icon: 'mdi mdi-pencil',
  class: 'p-button-outlined',
  command: () => emits('update:editMode', true),
}

const actionButton = computed(() => props.mainAction || actionModify)
const menuItems = computed(() => {
  const menuItems = props.items
  if (props.mainAction && !props.noModifyButton)
    menuItems?.unshift(translate(actionModify, t))
  return menuItems
})

const emits = defineEmits<{
  (e: 'update:editMode', value: boolean): void
}>()

const createdAt = computed(() =>
  props.resource?.createdAt
    ? moment(props.resource.createdAt).from(Now.value)
    : ''
)

const menu = ref()
const toggle = (event: { target: Element }) => menu.value.toggle(event)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.ResourceHeader {
  display: grid;
  flex: 0 0;
  grid-template-areas:
    'breadcrumb action menu'
    'createdAt  action menu';
  grid-template-rows: repeat(2, minmax(min-content, auto));
  grid-template-columns: 1fr repeat(2, minmax(min-content, auto));
  grid-gap: v.$spacing-2;
  align-items: center;
  justify-content: flex-start;
  min-width: 100%;
  padding-bottom: v.$spacing;
  border-bottom: solid 1px var(--surface-d);

  :first-child {
    flex: 1 1;
  }

  &__Action {
    grid-area: action;
    align-self: center;
  }

  &__MenuButton {
    grid-area: menu;
    padding: 0.2rem 0;
    font-size: 1.5rem;
  }

  &__CreatedAt {
    grid-area: createdAt;
    font-size: 0.8rem;
  }
}
</style>
